#include "../../libs/protocol/protocol.h"
#include <stdio.h>
#include <sys/wait.h>
#include <stdlib.h>
#include <unistd.h>

int main() {

	int pipe_to_child[2];

	if (pipe(pipe_to_child) == -1) {
		perror("pipe");
		exit(EXIT_FAILURE);
	}

	pid_t pid = fork();
	if (pid == -1) {
		perror("fork");
		exit(EXIT_FAILURE);
	}

	if (pid == 0) {				 // Child process
		close(pipe_to_child[1]); // Close write end of pipe

		// Redirect stdin to read from pipe_to_child
		dup2(pipe_to_child[0], STDIN_FILENO);

		execlp("./bin/djumbai_enqueue/djumbai_enqueue", "djumbai_enqueue", NULL);

		// If execlp fails
		perror("execlp");
		close(pipe_to_child[0]);
		exit(EXIT_FAILURE);
	} else {					 // Parent process
		close(pipe_to_child[0]); // Close read end of pipe

		unsigned char buffer[MESSAGE_SIZE];
		read(0, buffer, MESSAGE_SIZE);
		write(pipe_to_child[1], buffer, sizeof(buffer));

		// Close the write end of the pipe
		close(pipe_to_child[1]);
		// Wait for the child process to finish
		wait(NULL);
	}

	return 0;
}
